# vim: set colorcolumn= :
shopt -s expand_aliases

module load tinympi

#/bin/bash
# #     endpoints/node numtasks  numthreads  numnodes domain dec
declare -a configurations=( \
	'        2          01          8         6        20 20  24 '
	'        2          02          8         6        20 20  24 '
	'        2          04          8         6        20 20  24 '
	'        2          08          8         6        20 20  24 '
	'        2          01          8         6        20 20  48 '
	'        2          02          8         6        20 20  48 '
	'        2          04          8         6        20 20  48 '
	'        2          08          8         6        20 20  48 '
	'        2          01          8         6        20 20  72 '
	'        2          02          8         6        20 20  72 '
	'        2          04          8         6        20 20  72 '
	'        2          08          8         6        20 20  72 '
	'        2          01          8         6        20 20  96 '
	'        2          02          8         6        20 20  96 '
	'        2          04          8         6        20 20  96 '
	'        2          08          8         6        20 20  96 '
)

for configuration in "${configurations[@]}"; do
	rm lsb.*
	rm rank*
	eppernode=`sed 's/\s\+/ /g' <<<\"$configuration\" | sed 's/^\s*\(.*\)\s*$/\1/g' | cut -d ' ' -f2`
	numtasks=`sed 's/\s\+/ /g' <<<\"$configuration\" | sed 's/^\s*\(.*\)\s*$/\1/g' | cut -d ' ' -f3`
	numtasks_=$(echo $numtasks | sed 's/^0*//')
	numthreads=`sed 's/\s\+/ /g' <<<\"$configuration\" | sed 's/^\s*\(.*\)\s*$/\1/g' | cut -d ' ' -f4`
	numnodes=`sed 's/\s\+/ /g' <<<\"$configuration\" | sed 's/^\s*\(.*\)\s*$/\1/g' | cut -d ' ' -f5`
	xdsize=`sed 's/\s\+/ /g' <<<\"$configuration\" | sed 's/^\s*\(.*\)\s*$/\1/g' | cut -d ' ' -f6`
	ydsize=`sed 's/\s\+/ /g' <<<\"$configuration\" | sed 's/^\s*\(.*\)\s*$/\1/g' | cut -d ' ' -f7`
	zdsize=`sed 's/\s\+/ /g' <<<\"$configuration\" | sed 's/^\s*\(.*\)\s*$/\1/g' | cut -d ' ' -f8`
	zdsize_=`bc <<< $zdsize/$numtasks_`

	cd /cluster/home/mlukas/tmpi/tmpi/build.open_mpi2
	echo cmake -DTinyMPI_NUMBEROFTASKS:STRING=$numtasks_ -DTinyMPI_NUMBEROFTHREADS:STRING=$numthreads \
			-DTinyMPI_VERBSENDPOINTSPERNODE:STRING=$eppernode .
	cmake -DTinyMPI_NUMBEROFTASKS:STRING=$numtasks_ -DTinyMPI_NUMBEROFTHREADS:STRING=$numthreads \
			-DTinyMPI_VERBSENDPOINTSPERNODE:STRING=$eppernode .
	make -j12 benchmark

	cd /cluster/home/mlukas/benchmarks/HPCCG/tinympi/
	make VERBOSE=1 clean
	make VERBOSE=1 -j
	echo "@ mpirun -bynode -np $numnodes ./build/test_HPCCG $xdsize $ydsize ${zdsize_}"
	mpirun -bynode -np $numnodes ./build/test_HPCCG $xdsize $ydsize ${zdsize_}
	foldername=${eppernode}_${numtasks}_${numthreads}_${numnodes}_${xdsize}_${ydsize}_${zdsize}
	mkdir $foldername
	mv lsb.* $foldername
	mv CoMD* $foldername/statistics

done
