#define EXT_USESCIBENCH

#include <sstream>
#include <string>
#include <liblsb.h>
#include <tmpi.h>
#include <debug/debugger.h>
#include <random>
#include <algorithm>

#include <unistd.h>

#include <cassert>


/*
 * Rank 0 is the receiver, all other ranks are senders, they send messages in reverse order compared
 * with how rank 0 posts the receives.
 * */

int main(int argc, char** argv) {

	int N = atoi(argv[1]);
	assert(N > 2);

	int rank;
	int size;


	TMPI_Init(&argc, &argv);
	// musste ich in TMPI_Init verschieben (deshalb define EXT_USESCIBENCH), da dies für jeden thread
	// exakt einmal aufgerufen werden soll (und nicht für jeden task). kann zu einem späteren
	// Zeitpunkt wieder ändern.
// 	LSB_Init("tinympi", 0, 0);

	TMPI_Comm_size(TMPI_COMM_WORLD, &size);
	TMPI_Comm_rank(TMPI_COMM_WORLD, &rank);

	TMPI_Request *r = new TMPI_Request[N]; 
	TMPI_Status *st = new TMPI_Status[N];
	int* buf = new int[N*size];
	LSB_Set_Rparam_int("commsize", size);
	LSB_Set_Rparam_int("requests", N);

	LSB_Res();
	if (rank == 0) {
		int k = 0;
		// post n receives, with tag 0 ... n-1 from each peer
		for (int peer=1; peer<size; peer++) {
			for (int i=0; i<N; i++) {
				TMPI_Irecv(&buf[k++], 1, TMPI_INT, peer, i, TMPI_COMM_WORLD, &r[i]);
			}
		}
	}
	else {
		// post n sends, with tag n-1 ... 0 to rank 0
		for (int i=0; i<N; i++) {
			TMPI_Isend(&buf[i], 1, TMPI_INT, 0, N-(i+1), TMPI_COMM_WORLD, &r[i]);
		}
	}

	TMPI_Waitall(N, r, st);
	
	LSB_Rec(10);
// 	LSB_Finalize();
	TMPI_Finalize();

}
