// Copyright (c) 2016 ETH-Zurich. All rights reserved.
// Use of this source code is governed by a BSD-style license that
// can be found in the LICENSE file.

#ifndef _COMM_GLOBAL_COMMUNICATOR_H_635106f3226c46d3d114158785752466
#define _COMM_GLOBAL_COMMUNICATOR_H_635106f3226c46d3d114158785752466

#include "global.h"
#include "tasks.h"

namespace tinympi {

class Communicator;
class GlobalCommunicator {
	// the communicator is a friend class because they are essentially the same (except that they
	// are differently stored)
	friend class Communicator;

public:
	static void pre_init();
	static void post_finalize();

private:
	// a global communicator has the actual task mapping global_identifier -> task
	tasks::Task** task_mapping_;

	// unique communicator id
	comm_id_t id_;

	// number of tasks in communicator
	rank_type num_tasks_;

};

////////////////////////////////////
// THREAD LOCAL OBJECT
extern GlobalCommunicator gcomm_world_;

} // END NAMESAPCE tinympi

#endif //_COMM_GLOBAL_COMMUNICATOR
