// Copyright (c) 2016 ETH-Zurich. All rights reserved.
// Use of this source code is governed by a BSD-style license that
// can be found in the LICENSE file.

#ifndef _OFI_PROVIDER_H_635106f3226c46d3d114158785752466
#define _OFI_PROVIDER_H_635106f3226c46d3d114158785752466

#include <vector>

#include "rdma/fabric.h"
#include "rdma/fi_domain.h"
#include "rdma/fi_cm.h"
#include "rdma/fi_errno.h"
#include "rdma/fi_endpoint.h"
#include "rdma/fi_tagged.h"

#include "debug/debugger.h"

#include "global.h"

#include "ofi_endpoint.h"

namespace tinympi {
namespace ofi {
namespace impl {

//tinympi::ofi::impl
class OfiProvider {
public:
	void init();
	void finalize();

private:
	fid_fabric* fabric_;
	fid_domain* domain_;
	fid_cq* cq_;
	fid_ep* ep_;
	fid_av* av_;

	buflen_t max_inject_size_;

public:
	fid_cq* get_cq()                 { return cq_; }
	buflen_t get_max_inject_size()   { return max_inject_size_; }
	fid_ep* get_ep()                 { return ep_; }

////////////
// STATIC
public:
	static void setup_endpoints();
	static void destroy_endpoints();
};

extern OfiProvider provider_;
extern OfiEndpoint** endpoints_;
extern global_id_t num_endpoints_;

} // END NAMESPACE impl
} // END NAMESPACE ofi
} // END NAMESPACE tinympi

#endif // _OFI_PROVIDER_H
