// Copyright (c) 2016 ETH-Zurich. All rights reserved.
// Use of this source code is governed by a BSD-style license that
// can be found in the LICENSE file.

#include "verbs_rdvprovider.h"

namespace tinympi {
namespace verbs {
namespace impl {
	//////////////////////////////
	// sready send slots
	// we have a limited amount of sready send slots that can be used by
	// all endpoints
	RdvSReadyMessage*          RdvProvider::sready_send_slots_       = nullptr;
	// and the memory region
	ibv_mr*                    RdvProvider::sready_send_slots_mr_    = nullptr;

	// next send slot to be used
	thread_local uint_fast16_t RdvProvider::sready_send_slots_head_  = 0;
	// send slot base
	thread_local uint_fast16_t RdvProvider::sready_send_slots_start_ = 0;

	//////////////////////////////
	// rready send slots
	// we have a limited amount of rready send slots that can be used by
	// all endpoints
	RdvRReadyMessage*          RdvProvider::rready_send_slots_       = nullptr;
	// and the memory region
	ibv_mr*                    RdvProvider::rready_send_slots_mr_    = nullptr;

	// next send slot to be used
	thread_local uint_fast16_t RdvProvider::rready_send_slots_head_  = 0;
	// send slot base
	thread_local uint_fast16_t RdvProvider::rready_send_slots_start_ = 0;

} // END NAMESPACE impl
} // END NAMESPACE verbs
} // END NAMESPACE tinympi
