// Copyright (c) 2016 ETH-Zurich. All rights reserved.
// Use of this source code is governed by a BSD-style license that
// can be found in the LICENSE file.

#ifndef _THREADS_BARRIER_H_635106f3226c46d3d114158785752466
#define _THREADS_BARRIER_H_635106f3226c46d3d114158785752466

#include <atomic>

#include "debug/debugger.h"
#include "global.h"

namespace tinympi {
namespace threads {
namespace impl {

struct Barrier {
private:
	std::atomic<thread_id_t> cnt_;
	std::atomic<unsigned> generation_;

public:
	inline void init() {
		cnt_ = env::num_threads;
		generation_ = 0;
	}

	inline void wait() {
		const unsigned my_geneneration = generation_;
		TMPI_LOG_LEVEL(3, "Threads", "barrier");
		if (--cnt_ == 0) {
			cnt_ = env::num_threads;
			++generation_;
		} else {
			while (generation_ == my_geneneration) {
			}
		}
	}
};

} // END NAMESPACE impl
} // END NAMESPACE threads
} // END NAMESPACE tinympi

#endif // _THREADS_BARRIER_H_
