// Copyright (c) 2016 ETH-Zurich. All rights reserved.
// Use of this source code is governed by a BSD-style license that
// can be found in the LICENSE file.

#ifndef _THREADS_STACK_H_635106f3226c46d3d114158785752466
#define _THREADS_STACK_H_635106f3226c46d3d114158785752466

#include "thread_env.h"

namespace tinympi {
namespace threads {
namespace impl {

	// stores the state of the main thread to dest_addr (stacktop identifies the top of the main
	// threads' stack). From this function we will return when we call restore_stack. Therefore,
	// we return nullptr when we called copy_stack, and we will return the thread_context when we
	// return from resetore_stack
	thread_context* copy_stack(void* dest_addr, void* stacktop)
		asm("_copythreadstack");
	// restores a state on another thread, where new_stackptr points to the beginning of a copy of
	// the new stack, old_stackptr points to an address where we can store the old stackptr for later
	// recovering, and ctx is the thread context we pass to the new stack, which is the ONLY
	// available information for the new thread to identify itself
	void restore_stack(void* new_stackptr, void* old_stackptr, thread_context* ctx)
		asm("_restorestack");
	// recovers the threads correct stack, which is located at old_stack. we terminate pthreads
	// from there because it needs its own stack
	void recover_threadstack(void* old_stack)
		asm("_recoverthreadstack");

} // END NAMESPACE impl
} // END NAMESPACE threads
} // END NAMESPACE tinympi

#endif //_THREADS_STACK_H_
